package com.tourism.webadmin.back.service.impl;

import cn.hutool.core.collection.CollUtil;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.tourism.webadmin.back.model.constant.IsTrue;
import com.tourism.webadmin.back.service.*;
import com.tourism.webadmin.back.dao.*;
import com.tourism.webadmin.back.model.*;
import com.tourism.webadmin.config.DataSourceType;
import com.tourism.webadmin.upms.service.SysUserService;
import com.tourism.common.core.annotation.MyDataSource;
import com.tourism.common.core.base.dao.BaseDaoMapper;
import com.tourism.common.core.constant.GlobalDeletedFlag;
import com.tourism.common.core.object.MyRelationParam;
import com.tourism.common.core.object.CallResult;
import com.tourism.common.core.base.service.BaseService;
import com.tourism.common.core.util.MyModelUtil;
import com.tourism.common.sequence.wrapper.IdGeneratorWrapper;
import com.tourism.common.dict.service.GlobalDictService;
import com.github.pagehelper.Page;
import lombok.extern.slf4j.Slf4j;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.*;

/**
 * 聊天群聊成员数据操作服务类。
 *
 * @author 吃饭睡觉
 * @date 2024-09-06
 */
@Slf4j
@MyDataSource(DataSourceType.MAIN)
@Service("tourImMemberService")
public class TourImMemberServiceImpl extends BaseService<TourImMember, Long> implements TourImMemberService {

    @Autowired
    private IdGeneratorWrapper idGenerator;
    @Autowired
    private TourImMemberMapper tourImMemberMapper;
    @Autowired
    private TourImGroupService tourImGroupService;
    @Autowired
    private SysUserService sysUserService;
    @Autowired
    private GlobalDictService globalDictService;

    /**
     * 返回当前Service的主表Mapper对象。
     *
     * @return 主表Mapper对象。
     */
    @Override
    protected BaseDaoMapper<TourImMember> mapper() {
        return tourImMemberMapper;
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public TourImMember saveNew(TourImMember tourImMember) {
        tourImMemberMapper.insert(this.buildDefaultValue(tourImMember));
        return tourImMember;
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void saveNewBatch(List<TourImMember> tourImMemberList) {
        if (CollUtil.isNotEmpty(tourImMemberList)) {
            tourImMemberList.forEach(this::buildDefaultValue);
            tourImMemberMapper.insertList(tourImMemberList);
        }
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void saveNewBatch(List<TourImMember> tourImMemberList, int batchSize) {
        if (CollUtil.isEmpty(tourImMemberList)) {
            return;
        }
        if (batchSize <= 0) {
            batchSize = 10000;
        }
        int start = 0;
        do {
            int end = Math.min(tourImMemberList.size(), start + batchSize);
            List<TourImMember> subList = tourImMemberList.subList(start, end);
            // 如果数据量过大，同时当前表中存在createTime或updateTime等字段，可以考虑在外部创建一次 new Date()，
            // 然后传入buildDefaultValue，这样可以减少对象的创建次数，降低GC，提升效率。橙单之所以没有这样生成，是因为
            // 有些业务场景下需要按照这两个日期字段排序，因此我们只是在这里给出优化建议。
            subList.forEach(this::buildDefaultValue);
            tourImMemberMapper.insertList(subList);
            if (end == tourImMemberList.size()) {
                break;
            }
            start += batchSize;
        } while (true);
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public boolean update(TourImMember tourImMember, TourImMember originalTourImMember) {
        MyModelUtil.fillCommonsForUpdate(tourImMember, originalTourImMember);
        // 这里重点提示，在执行主表数据更新之前，如果有哪些字段不支持修改操作，请用原有数据对象字段替换当前数据字段。
        UpdateWrapper<TourImMember> uw = this.createUpdateQueryForNullValue(tourImMember, tourImMember.getId());
        return tourImMemberMapper.update(tourImMember, uw) == 1;
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public boolean remove(Long id) {
        return tourImMemberMapper.deleteById(id) == 1;
    }

    @Override
    public List<TourImMember> getTourImMemberList(TourImMember filter, String orderBy) {
        return tourImMemberMapper.getTourImMemberList(filter, orderBy);
    }

    @Override
    public List<TourImMember> getTourImMemberListWithRelation(TourImMember filter, String orderBy) {
        List<TourImMember> resultList = tourImMemberMapper.getTourImMemberList(filter, orderBy);
        // 在缺省生成的代码中，如果查询结果resultList不是Page对象，说明没有分页，那么就很可能是数据导出接口调用了当前方法。
        // 为了避免一次性的大量数据关联，规避因此而造成的系统运行性能冲击，这里手动进行了分批次读取，开发者可按需修改该值。
        int batchSize = resultList instanceof Page ? 0 : 1000;
        this.buildRelationForDataList(resultList, MyRelationParam.normal(), batchSize);
        return resultList;
    }

    @Override
    public CallResult verifyImportList(List<TourImMember> dataList, Set<String> ignoreFieldSet) {
        CallResult callResult;
        if (!CollUtil.contains(ignoreFieldSet, "isShow")) {
            callResult = verifyImportForConstDict(dataList, "isShowDictMap", TourImMember::getIsShow);
            if (!callResult.isSuccess()) {
                return callResult;
            }
        }
        if (!CollUtil.contains(ignoreFieldSet, "isTop")) {
            callResult = verifyImportForConstDict(dataList, "isTopDictMap", TourImMember::getIsTop);
            if (!callResult.isSuccess()) {
                return callResult;
            }
        }
        if (!CollUtil.contains(ignoreFieldSet, "isNotDisturb")) {
            callResult = verifyImportForConstDict(dataList, "isNotDisturbDictMap", TourImMember::getIsNotDisturb);
            if (!callResult.isSuccess()) {
                return callResult;
            }
        }
        if (!CollUtil.contains(ignoreFieldSet, "groupRole")) {
            callResult = verifyImportForGlobalDict(dataList, "groupRoleDictMap", TourImMember::getGroupRole);
            if (!callResult.isSuccess()) {
                return callResult;
            }
        }
        if (!CollUtil.contains(ignoreFieldSet, "groupId")) {
            callResult = verifyImportForDatasourceDict(dataList, "groupIdDictMap", TourImMember::getGroupId);
            if (!callResult.isSuccess()) {
                return callResult;
            }
        }
        if (!CollUtil.contains(ignoreFieldSet, "userId")) {
            callResult = verifyImportForDatasourceDict(dataList, "userIdDictMap", TourImMember::getUserId);
            if (!callResult.isSuccess()) {
                return callResult;
            }
        }
        return CallResult.ok();
    }

    @Override
    public CallResult verifyRelatedData(TourImMember tourImMember, TourImMember originalTourImMember) {
        String errorMessageFormat = "数据验证失败，关联的%s并不存在，请刷新后重试！";
        //这里是基于字典的验证。
        if (this.needToVerify(tourImMember, originalTourImMember, TourImMember::getGroupId)
                && !tourImGroupService.existId(tourImMember.getGroupId())) {
            return CallResult.error(String.format(errorMessageFormat, "聊天群组id"));
        }
        //这里是基于字典的验证。
        if (this.needToVerify(tourImMember, originalTourImMember, TourImMember::getGroupRole)
                && !globalDictService.existDictItemFromCache("GroupRole", tourImMember.getGroupRole())) {
            return CallResult.error(String.format(errorMessageFormat, "成员角色 1群主 2管理员 3普通成员"));
        }
        //这里是基于字典的验证。
        if (this.needToVerify(tourImMember, originalTourImMember, TourImMember::getUserId)
                && !sysUserService.existId(tourImMember.getUserId())) {
            return CallResult.error(String.format(errorMessageFormat, "用户id"));
        }
        return CallResult.ok();
    }

    private TourImMember buildDefaultValue(TourImMember tourImMember) {
        if (tourImMember.getId() == null) {
            tourImMember.setId(idGenerator.nextLongId());
        }
        MyModelUtil.fillCommonsForInsert(tourImMember);
        tourImMember.setDataState(GlobalDeletedFlag.NORMAL);
        MyModelUtil.setDefaultValue(tourImMember, "groupNickname", "");
        MyModelUtil.setDefaultValue(tourImMember, "groupRemark", "");
        MyModelUtil.setDefaultValue(tourImMember, "groupBackImage", "");
        MyModelUtil.setDefaultValue(tourImMember, "isShow", IsTrue.TRUE);
        MyModelUtil.setDefaultValue(tourImMember, "isTop", IsTrue.FALSE);
        MyModelUtil.setDefaultValue(tourImMember, "isNotDisturb", IsTrue.FALSE);
        return tourImMember;
    }
}
